% draw figures

% load YC data
inf_inc
load result0523

slide_fig = 1;

% making HP trend
y_pi_hp = zeros(size(y_pi));
y_pi_hp(:,:) = nan;

bs = [1 3 2 2];

for jj = 1:24
    
    for stdate = 1:length(y_pi)
        
        if isnan(y_pi(stdate,jj))~=1; break; end
        
    end
    
    y_pi_hp(stdate:end,jj) = hpfilter(y_pi(stdate:end,jj),1600);
    
end
    

close all;

table1 = zeros(7,4);

% figure for equim yield (baseline)
figure();
for cnt_case = 1:2
    
    if slide_fig == 1; subplot(1,2,cnt_case); else; subplot(2,2,cnt_case); end 
    
    plot([0,5,10],yc_n(:,cnt_case,bs(cnt_case))-yc_n_rn(:,cnt_case,bs(cnt_case)),'b','linewidth',2); hold on
    plot([0,5,10],yc_r(:,cnt_case,bs(cnt_case))-yc_r_rn(:,cnt_case,bs(cnt_case)),'b--','linewidth',2); 
    plot([0,5,10],yc_n(:,cnt_case,6)-yc_n_rn(:,cnt_case,6),'r-x','linewidth',1.5); 
    plot([0,5,10],nanmean(y_pi(2:end,cnt_case*6-2:cnt_case*6))*4-nanmean(y_pi(2:end,cnt_case*6-2))*4,'k-o','linewidth',1.0);  
    plot([0,5,10],zeros(3,1),'k-','linewidth',0.5); hold off
    axis([0 10 -.5 1.5]);  
    
    table1(1,cnt_case*2-1:cnt_case*2) = nanmean(y_pi(2:end,cnt_case*6-1:cnt_case*6))'*4-nanmean(y_pi(2:end,cnt_case*6-2))'*4;  
    table1(2,cnt_case*2-1:cnt_case*2) = yc_n(2:3,cnt_case,bs(cnt_case))'-yc_n_rn(2:3,cnt_case,bs(cnt_case))';
    table1(3,cnt_case*2-1:cnt_case*2) = yc_n(2:3,cnt_case,6)'-yc_n_rn(2:3,cnt_case,6)';
    table1(4,cnt_case*2-1:cnt_case*2) = yc_r(2:3,cnt_case,bs(cnt_case))'-yc_r_rn(2:3,cnt_case,bs(cnt_case))';
    table1(5,cnt_case*2-1:cnt_case*2) = yc_r(2:3,cnt_case,6)'-yc_r_rn(2:3,cnt_case,6)';
    table1(6,cnt_case*2-1:cnt_case*2) = yc_n(2:3,cnt_case,8)'-yc_n_rn(2:3,cnt_case,8)';
    table1(7,cnt_case*2-1:cnt_case*2) = yc_r(2:3,cnt_case,8)'-yc_r_rn(2:3,cnt_case,8)';

    switch cnt_case

        case 1; title('U.S.');
        case 2; title('U.K.'); 

    end
    
end
legend('Nominal (Stochastic trend)','Real (Stochastic trend)','Nominal (Trend statioinary)','Data')


% Robustness check
figure();
r_s = [1 10 11 9];
for r_case = 1:4
    
    subplot(2,2,r_case)
    
    if r_case > 1
        plot([0,5,10],yc_n(:,1,1)-yc_n_rn(:,1,1),'b-','linewidth',2); hold on
        plot([0,5,10],yc_n(:,1,r_s(r_case))-yc_n_rn(:,1,r_s(r_case)),'r--','linewidth',2); 
        plot([0,5,10],nanmean(y_pi(2:end,6-2:6))*4-nanmean(y_pi(2:end,6-2))*4,'k-o','linewidth',1);  
        plot([0,5,10],zeros(3,1),'k-','linewidth',1.0); hold off
        axis([0 10 0 1.5]); 
    else
        plot([0,5,10],yc_n(:,1,3)-yc_n_rn(:,1,3),'g-.','linewidth',2); hold on
        plot([0,5,10],yc_n(:,1,1)-yc_n_rn(:,1,1),'b-','linewidth',2); 
        plot([0,5,10],yc_n(:,1,2)-yc_n_rn(:,1,2),'r--','linewidth',2); 
        plot([0,5,10],nanmean(y_pi(2:end,6-2:6))*4-nanmean(y_pi(2:end,6-2))*4,'k-o','linewidth',1.5);  
        plot([0,5,10],zeros(3,1),'k-','linewidth',0.5); hold off
        axis([0 10 -.5 3]);  
    end
    
    switch r_case
        
        case 1; title('Different CRRA coefficient'); legend('\alpha = 20','\alpha = 40','\alpha = 150','Data')
        case 2; title('Habit formation'); legend('h = 0 (Baseline)','h = 0.25', 'Data')
        case 3; title('Trend inflation'); legend('with trend inflation)','w/o trend inflation', 'Data')
        case 4; title('Response to output gap'); legend('\phi_{y}=0.0 (Baseline)','\phi_{y}=0.5', 'Data')

    end
    
end


% figure for equim yield by MP rule
figure();
mp_cases = [1 4 5; 5 4 3];
for cnt_case = 1:2
    
    if slide_fig == 1; subplot(1,2,cnt_case); else subplot(1,2,cnt_case); end 
    
    plot([0,5,10],yc_n(:,cnt_case,mp_cases(cnt_case,3))-yc_n_rn(:,cnt_case,mp_cases(cnt_case,3)),'g-.','linewidth',2);  hold on
    plot([0,5,10],yc_n(:,cnt_case,mp_cases(cnt_case,1))-yc_n_rn(:,cnt_case,mp_cases(cnt_case,1)),'r-','linewidth',2); 
    plot([0,5,10],yc_n(:,cnt_case,mp_cases(cnt_case,2))-yc_n_rn(:,cnt_case,mp_cases(cnt_case,2)),'b--','linewidth',2);  
    plot([0,5,10],nanmean(y_pi(2:end,cnt_case*6-2:cnt_case*6))*4-nanmean(y_pi(2:end,cnt_case*6-2))*4,'k-o','linewidth',1.5);  
    plot([0,5,10],zeros(3,1),'k-','linewidth',1.0); hold off
    axis([0 10 0 3]);  
    
    switch cnt_case

        case 1; title('U.S.'); 
        case 2; title('U.K.'); 

    end
 
end
legend('\phi_{\pi}=1.0','\phi_{\pi}=2.0','\phi_{\pi}=3.0','Data')


% volatility
vol_G4_d = zeros(4,3,2);
vol_G4_m = zeros(4,3,2);

for cnt_case = 1:4
    
    vol_G4_d(cnt_case,:,1) = nanstd(y_pi(:,cnt_case*6-2:cnt_case*6)); 
    vol_G4_d(cnt_case,:,2) = nanstd(y_pi(:,cnt_case*6-2:cnt_case*6)-y_pi_hp(:,cnt_case*6-2:cnt_case*6)); 

    vol_G4_m(cnt_case,:,1) = std_ypcr(4:end,cnt_case,1,1)'; 
    vol_G4_m(cnt_case,:,2) = std_ypcr(4:end,cnt_case,11,1)';
    
end


figure;
for cnt_case = 1:2
    
    if slide_fig == 1; subplot(1,2,cnt_case); else subplot(1,2,cnt_case); end 
    
    plot([0,5,10],vol_G4_m(cnt_case,:,1)/vol_G4_m(cnt_case,1,1),'k-','linewidth',3); hold on
    plot([0,5,10],vol_G4_m(cnt_case,:,2)/vol_G4_m(cnt_case,1,2),'b--','linewidth',2);  
    plot([0,5,10],vol_G4_d(cnt_case,:,1)/vol_G4_d(cnt_case,1,1),'k-o','linewidth',1); 
    plot([0,5,10],vol_G4_d(cnt_case,:,2)/vol_G4_d(cnt_case,1,2),'b--o','linewidth',1);  
    plot([0,5,10],zeros(3,1),'k-','linewidth',1.0); hold off
    axis([0 10 0.0 1]);  
    
    switch cnt_case

        case 1; title('U.S.'); 
        case 2; title('U.K.'); 

    end

end
legend('Model','Model (w/o trend inflation)','Data','Data (detrend by HP filter)')


%% L4L
load l4l0612
load freq_elb
table2 = zeros(7,4);
table3 = zeros(7,4);
table4 = zeros(7,4);

freq_elb

for cnt_case = 1:2
    
    table2(1,cnt_case*2-1:cnt_case*2) = yc_n(2:3,cnt_case,7)'-yc_n_rn(2:3,cnt_case,7)';
    table2(2,cnt_case*2-1:cnt_case*2) = yc_r(2:3,cnt_case,7)'-yc_r_rn(2:3,cnt_case,7)';
    table2(3,cnt_case*2-1:cnt_case*2) = yc_n(2:3,cnt_case,12)'-yc_n_rn(2:3,cnt_case,12)';
    table2(4,cnt_case*2-1:cnt_case*2) = yc_r(2:3,cnt_case,12)'-yc_r_rn(2:3,cnt_case,12)';
    table2(5,cnt_case*2-1:cnt_case*2) = yc_n(2:3,cnt_case,8)'-yc_n_rn(2:3,cnt_case,8)';
    table2(6,cnt_case*2-1:cnt_case*2) = yc_r(2:3,cnt_case,8)'-yc_r_rn(2:3,cnt_case,8)';
    table2(7,cnt_case*2-1:cnt_case*2) = yc_n(2:3,cnt_case,13)'-yc_n_rn(2:3,cnt_case,13)';
    table2(8,cnt_case*2-1:cnt_case*2) = yc_r(2:3,cnt_case,13)'-yc_r_rn(2:3,cnt_case,13)';

end

table2

for cnt_case = 1:2
    
    table3(1,cnt_case*2-1:cnt_case*2) = yc_n_el(2:3,cnt_case,7)'-yc_n_rn_el(2:3,cnt_case,7)';
    table3(2,cnt_case*2-1:cnt_case*2) = yc_n_el(2:3,cnt_case,12)'-yc_n_rn_el(2:3,cnt_case,12)';
    table3(3,cnt_case*2-1:cnt_case*2) = yc_n_el(2:3,cnt_case,8)'-yc_n_rn_el(2:3,cnt_case,8)';
    table3(4,cnt_case*2-1:cnt_case*2) = yc_n_el(2:3,cnt_case,13)'-yc_n_rn_el(2:3,cnt_case,13)';

end

table3

for cnt_case = 1:2
    
    table4(1,cnt_case*2-1:cnt_case*2) = yc_n_ab(2:3,cnt_case,7)'-yc_n_rn_ab(2:3,cnt_case,7)';
    table4(2,cnt_case*2-1:cnt_case*2) = yc_n_ab(2:3,cnt_case,12)'-yc_n_rn_ab(2:3,cnt_case,12)';
    table4(3,cnt_case*2-1:cnt_case*2) = yc_n_ab(2:3,cnt_case,8)'-yc_n_rn_ab(2:3,cnt_case,8)';
    table4(4,cnt_case*2-1:cnt_case*2) = yc_n_ab(2:3,cnt_case,13)'-yc_n_rn_ab(2:3,cnt_case,13)';

end

table4

table_l4l = [table2(1,2),table2(2,2),freq_elb(1,7), table2(1,4),table2(2,4),freq_elb(2,7);...
             table2(3,2),table2(4,2),freq_elb(1,12),table2(3,4),table2(4,4),freq_elb(2,12);...
             table2(3,2)-table2(1,2),table2(4,2)-table2(2,2),0,table2(3,4)-table2(1,4),table2(4,4)-table2(2,4),0;...
             table2(5,2),table2(6,2),freq_elb(1,8) ,table2(5,4),table2(6,4),freq_elb(2,8);...
             table2(5,2)-table2(1,2),table2(6,2)-table2(2,2),0,table2(5,4)-table2(1,4),table2(6,4)-table2(2,4),0;...
             table2(7,2),table2(8,2),freq_elb(1,13),table2(7,4),table2(8,4),freq_elb(2,13);...
             table2(7,2)-table2(1,2),table2(8,2)-table2(2,2),0,table2(7,4)-table2(1,4),table2(8,4)-table2(2,4),0];
     
table_l4l

%% subsample
load sub0612
for cnt_case = 1:2
   
    table1(1,cnt_case*2-1:cnt_case*2) = nanmean(y_pi(2:end,cnt_case*6-1:cnt_case*6))'*4-nanmean(y_pi(2:end,cnt_case*6-2))'*4;  
    table1(2,cnt_case*2-1:cnt_case*2) = yc_n(2:3,cnt_case,bs(cnt_case))'-yc_n_rn(2:3,cnt_case,bs(cnt_case))';
    table1(3,cnt_case*2-1:cnt_case*2) = yc_n(2:3,cnt_case,6)'-yc_n_rn(2:3,cnt_case,6)';
    table1(4,cnt_case*2-1:cnt_case*2) = yc_r(2:3,cnt_case,bs(cnt_case))'-yc_r_rn(2:3,cnt_case,bs(cnt_case))';
    table1(5,cnt_case*2-1:cnt_case*2) = yc_r(2:3,cnt_case,6)'-yc_r_rn(2:3,cnt_case,6)';
    table1(6,cnt_case*2-1:cnt_case*2) = yc_n(2:3,cnt_case,8)'-yc_n_rn(2:3,cnt_case,8)';
    table1(7,cnt_case*2-1:cnt_case*2) = yc_r(2:3,cnt_case,8)'-yc_r_rn(2:3,cnt_case,8)';
   
end

