% This subroutine is for "Linear Interpolation"
% Note that it is applicable ONLY to uniform grids, but it is faster
function [wx, jx] = inter_weight2(nx, x, nn)
% NX: actual amount, X: variable, WX(1): weight for lower point, WX(2): weight for upper point, 
% jX(1): lower point, jx(2):upper point, NN: the number of grids
    wx = zeros(2,1);
    
    if nn == 1
        
        wx = [0.5; 0.5];
        jx = [1; 1];
        
    else
        
        if ( nx >= x(nn) ) % The case that optimal amount is BIGGER than the BIGGEST value of grid

            wx(1) = (x(nn)-nx)/(x(nn)-x(nn-1));
            wx(2) = (nx-x(nn-1))/(x(nn)-x(nn-1));
            jx(1)  = nn-1;
            jx(2)  = nn;

        elseif ( nx <= x(1) ) % The case that optimal amount is SMALER than the SMALEST value of grid

            wx(1) = (x(2)-nx)/(x(2)-x(1));
            wx(2) = (nx-x(1))/(x(2)-x(1));
            jx(1) = 1;
            jx(2) = 2;

        else                  % The case that optimal amount is among grids.

            jx(1) = 1 + floor(( nx-x(1) ) / ( (x(nn)-x(1))/(nn-1) ));
            jx(2) = 2 + floor(( nx-x(1) ) / ( (x(nn)-x(1))/(nn-1) ));
            wx(1) = (x(jx(2)) - nx)/(x(jx(2))-x(jx(1)));
            wx(2) = (nx - x(jx(1)))/(x(jx(2))-x(jx(1)));

        end
        
    end
    
end