%
% This function m-file is for loading data
%-----------------------------------------------

cd 'C:\Users\mitsu\Dropbox\01Rsearch\JMCB 2021\term\code JMCB\term04\term04'

switch cnt_case

    case 1; cd 'c1US'
    case 2; cd 'c2UK'

end

if     robus_f == 6 ; cd '06stat/'; 
elseif robus_f == 14; cd '14ut87/'; 
elseif robus_f == 15; cd '15af87/'; 
end

% load grids
load gridy.txt; load gridp.txt; load gridg.txt; load mcyp.txt; load gpistar.txt
gstar  = exp(gpistar(1));
pistar = exp(gpistar(2));

if robus_f == 6

    gridy(:) = gstar;
    
end

ngriy = length(gridy); ngrip = length(gridp); ngrig= length(gridg); ngriyp = ngriy*ngrip*ngrig;

if ( robus_f > 3 && robus_f ~= 10 )
    
    ngrit = 1; gridt = 1.0; mct = 1.0;

else % note that L4L does cannot have time-varying trend inflation
   
    load gridt.txt;  load mct.txt; ngrit = length(gridt);

end

% making all grids as GAPS to be consistent with data
gridp = gridp/pistar;
gridy = gridy/gstar;

%% those steady state values will be used for the level of interest rate
% if ( robus_f == 8 ) % L4L: zero growth and zero inflation
% 
%     pistar = 1.0;
%     gstar  = 1.0;
% 
% elseif ( robus_f == 12 ) % L4L: moderately low for long
% 
%     pistar = 1.015^0.25;
%     gstar  = 1.015^0.25;
% 
% elseif ( robus_f == 13 ) % L4L: negative growth and negative inflation
% 
%     pistar = 0.995^0.25;
%     gstar  = 0.995^0.25;
% 
% end


switch robus_f 

    case (1) ; cd '01base'
    case (2) ; cd '02hris'
    case (3) ; cd '03lris'
    case (4) ; cd '04hphp'
    case (5) ; cd '05lphp'
    case (7) ; cd '07elb_'
    case (8) ; cd '08l4l_'
    case (9) ; cd '09phy_'
    case (10); cd '10hab_'
    case (11); cd '11woti'
    case (12); cd '12l4lh'
    case (13); cd '13l4ll'
    
end

% load grids
load gridb.txt; load gridr.txt; load gridc.txt; 

ngrib = length(gridb); ngrir = length(gridr); ngric = length(gridc); 

%% load policy functions
   
load c_t.txt; load b_t.txt; 

c_t2 = ones(ngriyp,ngrit,ngrib,ngrir,ngric);  
b_t2 = ones(ngriyp,ngrit,ngrib,ngrir,ngric);   

% reshape the Fortran version policy functions
for dc = 1:ngric
for dr = 1:ngrir
for db = 1:ngrib

    pos_gri = 1 + ngriyp*ngrib*ngrir*(dc-1) + ngriyp*ngrib*(dr-1) + ngriyp*(db-1) ;

    c_t2(:,:,db,dr,dc) = c_t(pos_gri:pos_gri+ngriyp-1,:);
    b_t2(:,:,db,dr,dc) = b_t(pos_gri:pos_gri+ngriyp-1,:);

end
end
end

c_t = c_t2; b_t = b_t2; 
clear c_t2 b_t2;

load yie0_n.txt; load yie1_n.txt; load yie2_n.txt; load yie3_n.txt; load yie4_n.txt; 
load yie5_n.txt; load yie10_n.txt; load yie0_r.txt; load yie5_r.txt; load yie10_r.txt; 

% yield curve by tenor(1,20,40) and types(nominal,nominal&risk-neutral,real,real&risk-neurtral)
pol_yie = cell(3,4);

% nominal yield curve by 0,1,2,3,4,5-year and types(nominal,nominal&risk-neutral)
pol_nts = cell(6,2);

yie0_n2  = ones(ngriyp,ngrit,ngrib,ngrir,ngric,2);   
yie1_n2  = ones(ngriyp,ngrit,ngrib,ngrir,ngric,2);   
yie2_n2  = ones(ngriyp,ngrit,ngrib,ngrir,ngric,2);   
yie3_n2  = ones(ngriyp,ngrit,ngrib,ngrir,ngric,2);   
yie4_n2  = ones(ngriyp,ngrit,ngrib,ngrir,ngric,2);   
yie5_n2  = ones(ngriyp,ngrit,ngrib,ngrir,ngric,2);   
yie10_n2 = ones(ngriyp,ngrit,ngrib,ngrir,ngric,2); 

yie0_r2  = ones(ngriyp,ngrit,ngrib,ngrir,ngric,2);   
yie5_r2  = ones(ngriyp,ngrit,ngrib,ngrir,ngric,2);   
yie10_r2 = ones(ngriyp,ngrit,ngrib,ngrir,ngric,2);   

for dt = 1:2
for dc = 1:ngric
for dr = 1:ngrir
for db = 1:ngrib

    pos_gri = 1 + ngriyp*ngrib*ngrir*ngric*(dt-1) + ngriyp*ngrib*ngrir*(dc-1) + ngriyp*ngrib*(dr-1) + ngriyp*(db-1) ;

    yie0_n2(:,:,db,dr,dc,dt) = yie0_n(pos_gri:pos_gri+ngriyp-1,:);
    yie1_n2(:,:,db,dr,dc,dt) = yie1_n(pos_gri:pos_gri+ngriyp-1,:);
    yie2_n2(:,:,db,dr,dc,dt) = yie2_n(pos_gri:pos_gri+ngriyp-1,:);
    yie3_n2(:,:,db,dr,dc,dt) = yie3_n(pos_gri:pos_gri+ngriyp-1,:);
    yie4_n2(:,:,db,dr,dc,dt) = yie4_n(pos_gri:pos_gri+ngriyp-1,:);
    yie5_n2(:,:,db,dr,dc,dt) = yie5_n(pos_gri:pos_gri+ngriyp-1,:);
    yie10_n2(:,:,db,dr,dc,dt) = yie10_n(pos_gri:pos_gri+ngriyp-1,:);
    
    yie0_r2(:,:,db,dr,dc,dt) = yie0_r(pos_gri:pos_gri+ngriyp-1,:);
    yie5_r2(:,:,db,dr,dc,dt) = yie5_r(pos_gri:pos_gri+ngriyp-1,:);
    yie10_r2(:,:,db,dr,dc,dt) = yie10_r(pos_gri:pos_gri+ngriyp-1,:);

end
end
end
end

clear yie0_n yie1_n yie2_n yie3_n yie4_n yie5_n yie10_n; 
clear yie0_r yie5_r yie10_r; 

% nominal and real yield-curve
pol_yie{1,1} = yie0_n2(:,:,:,:,:,1) ;
pol_yie{1,2} = yie0_n2(:,:,:,:,:,2) ;
pol_yie{1,3} = yie0_r2(:,:,:,:,:,1) ;
pol_yie{1,4} = yie0_r2(:,:,:,:,:,2) ;

pol_yie{2,1} = yie5_n2(:,:,:,:,:,1) ;
pol_yie{2,2} = yie5_n2(:,:,:,:,:,2) ;
pol_yie{2,3} = yie5_r2(:,:,:,:,:,1) ;
pol_yie{2,4} = yie5_r2(:,:,:,:,:,2) ;

pol_yie{3,1} = yie10_n2(:,:,:,:,:,1) ;
pol_yie{3,2} = yie10_n2(:,:,:,:,:,2) ;
pol_yie{3,3} = yie10_r2(:,:,:,:,:,1) ;
pol_yie{3,4} = yie10_r2(:,:,:,:,:,2) ;

% nominal term-structure
pol_nts{1,1} = yie0_n2(:,:,:,:,:,1) ;
pol_nts{1,2} = yie0_n2(:,:,:,:,:,2) ;
  
pol_nts{2,1} = yie1_n2(:,:,:,:,:,1) ;
pol_nts{2,2} = yie1_n2(:,:,:,:,:,2) ;
    
pol_nts{3,1} = yie2_n2(:,:,:,:,:,1) ;
pol_nts{3,2} = yie2_n2(:,:,:,:,:,2) ;
    
pol_nts{4,1} = yie3_n2(:,:,:,:,:,1) ;
pol_nts{4,2} = yie3_n2(:,:,:,:,:,2) ;
    
pol_nts{5,1} = yie4_n2(:,:,:,:,:,1) ;
pol_nts{5,2} = yie4_n2(:,:,:,:,:,2) ;
    
pol_nts{6,1} = yie5_n2(:,:,:,:,:,1) ;
pol_nts{6,2} = yie5_n2(:,:,:,:,:,2) ;
    
clear yie0_n2 yie1_n2 yie2_n2 yie3_n2 yie4_n2 yie5_n2 yie10_n2; 
clear yie0_r2 yie5_r2 yie10_r2; 

cd 'C:\Users\mitsu\Dropbox\01Rsearch\JMCB 2021\term\code JMCB'
