% simulation path
close all; clc
clear; 

data_sim = 0; % 0: using real data, 1: using simulated series

% length of impulse responses
irf_len = 21;
burn_irf = 500; % burn-out for impulse

% moment and YC
std_ypcr    = zeros(6,4,15,2); %(variable,country,h-t-m)
std_ypcr_y  = zeros(6,4,15,2); %(variable,country,h-t-m)
std_ypcr_2  = zeros(6,4,15,2); %(variable,country,h-t-m)
auto_ypcr   = zeros(6,4,15,2);
corr_p_yc   = zeros(4,4,15,2);
corr_p_yc_y = zeros(4,4,15,2);
corr_p_yc_2 = zeros(4,4,15,2);
corr_p_yc_5 = zeros(4,4,15,2);

yc_n     = zeros(3,4,15); %(tenor,country,robustness)
yc_r     = zeros(3,4,15);
yc_n_rn  = zeros(3,4,15);
yc_r_rn  = zeros(3,4,15);

yc_n_el     = zeros(3,4,15); %(tenor,country,robustness) at elb
yc_r_el     = zeros(3,4,15);
yc_n_rn_el  = zeros(3,4,15);
yc_r_rn_el  = zeros(3,4,15);

yc_n_ab     = zeros(3,4,15); %(tenor,country,robustness) above elb
yc_r_ab     = zeros(3,4,15);
yc_n_rn_ab  = zeros(3,4,15);
yc_r_rn_ab  = zeros(3,4,15);

freq_elb = zeros(4,15); % frequency of elb 

%impulse responses
% irf_yp   = zeros(2,irf_len+burn_irf);
% irf_bon  = ones(irf_len+burn_irf,2)*5.0;
% irf_con  = zeros(irf_len+burn_irf,2);
% irf_rate = cell(3,4);

for tenr = 1:3
for rtyp = 1:4

    irf_rate{tenr,rtyp} = ones(irf_len+burn_irf,1,2);

end
end

for cnt_case = 1:2    
for robus_f  = 1:15
    
%     if ( robus_f ~= 7 && robus_f ~= 8 && robus_f ~= 12 && robus_f ~= 13 ); continue; end
    if ( robus_f > 8 && cnt_case > 1 && robus_f < 11 ); continue; end
    if ( robus_f > 3 && cnt_case > 2 && robus_f ~= 6 ); continue; end
        
    % ----------parameters-------------
    if     robus_f == 6 ; var_params_st
    elseif robus_f == 14; var_params_ti_ut87
    elseif robus_f == 15; var_params_ti_af87
    else;                 var_params_ti
    end
    
    % ----------load data-------------
    load_data_fortran

    m_y = floor(ngriy/2+1); 
    m_g = floor(ngrig/2+1); 
    m_p = floor(ngrip/2+1); 
    m_t = floor(ngrit/2+1); 
    m_b = floor(ngrib/2+1);
    m_r = floor(ngrir/2+1);
    m_c = floor(ngric/2+1);
    
    
    % ------------ start simulation !! ---------------
    
    if data_sim == 0 % using estimated values by real data
        
        % -------load data------------
        if robus_f == 6; load gaps_g4_st
        else;            load gaps_g4
        end
        
        switch cnt_case
            
            % starting periods for each country
            case 1; if robus_f==15; star_d=123; else; star_d = 8; end
            case 2; if robus_f==15; star_d=123; else; star_d = 1; end
            case 3; star_d = 73;
            case 4; star_d = 73;
            
        end
        end_d = length(gap_est);
        if robus_f == 14; end_d=122; end
        
        % data for output growth and inflation
        sim_len = end_d-star_d+1;
                
        sim_yp = ones(3,sim_len) ;
        
        sim_yp(1,:) = exp(gap_est(star_d:end_d,cnt_case*4-3)'/100);   % income growth
        sim_yp(2,:) = exp(gap_est(star_d:end_d,cnt_case*4  )'/100);   % inflation gap
        sim_yp(3,:) = exp(gap_est(star_d:end_d,cnt_case*4-2)'/100);   % income gap
        sim_t       = exp(gap_est(star_d:end_d,cnt_case*4-1)'/100);   % trend inflation
        
        if ( robus_f > 3 && robus_f ~= 10 ); sim_t(:) = 1.0; end
        
    elseif data_sim == 1    % using simulated series rather than real data
        
        sim_len = 10000;

        sim_yp = ones(3,sim_len) ;
        sim_t  = ones(1,sim_len) ;
        
        sim_yp(1,1) = gridy(floor(ngriy/2+1)) ;
        sim_yp(2,1) = gridp(floor(ngrip/2+1)) ;
        sim_yp(3,1) = gridg(floor(ngrig/2+1)) ;
        sim_t(1,1)  = gridt(floor(ngrit/2+1)) ;
    
    end
    
    % simulation path
    sim_bon  = ones(sim_len,1)*4.8;
    sim_con  = ones(sim_len,1)*1.00 ;
    sim_rate = cell(3,4);
    sim_nts  = cell(6,2);

    % initial varlue: interest rate
    [wr, jr] = inter_weight2(log(rstar), log(gridr), ngrir) ;

    for tenr = 1:3
    for rtyp = 1:4

        sim_rate{tenr,rtyp} = ones(sim_len,1)*...
            (wr(1)*pol_yie{tenr,rtyp}(ngrip*ngrig*(m_y-1)+ngrig*(m_p-1)+m_g,m_t,m_b,jr(1),m_c)...
            +wr(2)*pol_yie{tenr,rtyp}(ngrip*ngrig*(m_y-1)+ngrig*(m_p-1)+m_g,m_t,m_b,jr(2),m_c));

    end
    end
    
% --------- generate the simulated path period by period from here --------
    for peri = 2:sim_len
        
        % when using the simulated data, shocks are randomely generated 
        if data_sim == 1
        
            % income and inflation
            sim_yp(:,peri) = exp(A1 + A2*log(sim_yp(:,peri-1)+gpistar) + mvnrnd(zeros(length(A1),1),SIGMA)' - gpistar); 
            % Note: subtract the SS values to be consistent with grids
            
            if ( robus_f < 4 || robus_f == 10 )
                % target inflation
                sim_t(peri) = exp(AR1*log(sim_t(peri-1)) + randn*SIGE/100);
            end
            
        end
        
        % interpolation
        if robus_f == 6; wy(:)=0.5; jy = [m_y m_y+1]; else
        [wy, jy] = inter_weight2( log(sim_yp(1,peri)), log(gridy), ngriy ) ; end
        [wp, jp] = inter_weight2( log(sim_yp(2,peri)), log(gridp), ngrip ) ;
        [wg, jg] = inter_weight2( log(sim_yp(3,peri)), log(gridg), ngrig ) ;
        [wt, jt] = inter_weight2( log(sim_t(peri)), log(gridt), ngrit ) ;
        [wb, jb] = inter_weight2( sim_bon(peri-1), gridb, ngrib) ;
        [wr, jr] = inter_weight2( log(sim_rate{1,1}(peri-1)), log(gridr), ngrir ) ;
        [wc, jc] = inter_weight2( sim_con(peri-1), gridc, ngric ) ;

        sim_con(peri) = 0; sim_bon(peri) = 0; 
        
        for ddy = 1:2
        for ddp = 1:2
        for ddg = 1:2
        for ddt = 1:2
        for ddb = 1:2
        for ddr = 1:2
        for ddc = 1:2

            sim_con(peri) = sim_con(peri) + wy(ddy)*wp(ddp)*wg(ddg)*wt(ddt)*wb(ddb)*wr(ddr)*wc(ddc)...
                *c_t(ngrip*ngrig*(jy(ddy)-1)+ngrig*(jp(ddp)-1)+jg(ddg),jt(ddt),jb(ddb),jr(ddr),jc(ddc)); 

            sim_bon(peri) = sim_bon(peri) + wy(ddy)*wp(ddp)*wg(ddg)*wt(ddt)*wb(ddb)*wr(ddr)*wc(ddc)...
                *b_t(ngrip*ngrig*(jy(ddy)-1)+ngrig*(jp(ddp)-1)+jg(ddg),jt(ddt),jb(ddb),jr(ddr),jc(ddc));  

        end
        end
        end
        end
        end
        end
        end

        % yield curve (nominal and real) 
        for tenr = 1:3  %0,5,10-year
        for rtyp = 1:4 

            sim_rate{tenr,rtyp}(peri) = 0.0;

        for ddy = 1:2
        for ddp = 1:2
        for ddg = 1:2
        for ddt = 1:2
        for ddb = 1:2
        for ddr = 1:2
        for ddc = 1:2

            sim_rate{tenr,rtyp}(peri) = sim_rate{tenr,rtyp}(peri) + ...
                wy(ddy)*wp(ddp)*wg(ddg)*wt(ddt)*wb(ddb)*wr(ddr)*wc(ddc)...
                *log(pol_yie{tenr,rtyp}(ngrip*ngrig*(jy(ddy)-1)+ngrig*(jp(ddp)-1)+jg(ddg),jt(ddt),jb(ddb),jr(ddr),jc(ddc))) ;

        end
        end
        end
        end
        end
        end
        end

            sim_rate{tenr,rtyp}(peri) = exp(sim_rate{tenr,rtyp}(peri)) ;
            
            
        end
        end
               
        % nominal term structure up to 5-year
        for tenr = 1:6
        for rtyp = 1:2

            sim_nts{tenr,rtyp}(peri) = 0.0;

        for ddy = 1:2
        for ddp = 1:2
        for ddg = 1:2
        for ddt = 1:2
        for ddb = 1:2
        for ddr = 1:2
        for ddc = 1:2

            sim_nts{tenr,rtyp}(peri) = sim_nts{tenr,rtyp}(peri) + ...
                    wy(ddy)*wp(ddp)*wg(ddg)*wt(ddt)*wb(ddb)*wr(ddr)*wc(ddc)...
                    *log(pol_nts{tenr,rtyp}(ngrip*ngrig*(jy(ddy)-1)+ngrig*(jp(ddp)-1)+jg(ddg),jt(ddt),jb(ddb),jr(ddr),jc(ddc))) ;

        end
        end
        end
        end
        end
        end
        end

            sim_nts{tenr,rtyp}(peri) = exp(sim_nts{tenr,rtyp}(peri)) ;

        end
        end
        
        if mod(peri,100) == 0; disp(peri); end
        
    end %-------------- simulation ends!-----------------
    
    
    if     data_sim == 0; burnout = 2;
    elseif data_sim == 1; burnout = 102;
    end
    
    % moments are computed only for baseline case
    if robus_f > 0
        
        for htm = 1:2
            
            % hand to mouth consumers
            if     htm == 1; h_t_m = 0.0;
            elseif htm == 2; h_t_m = 0.25;
            end
            
            sim_ginc = sim_yp(3,burnout:end)./sim_yp(3,burnout-1:end-1).*sim_yp(1,burnout:end);
            sim_gcon = ((1-h_t_m)*sim_con(burnout:end)+h_t_m*sim_yp(3,burnout:end)')./((1-h_t_m)*sim_con(burnout-1:end-1)+h_t_m*sim_yp(3,burnout-1:end-1)').*sim_yp(1,burnout:end)';
            sim_tinf = ones(length(sim_ginc),1);
            %sim_incl = ones(length(sim_ginc),1);

            % make the LEVEL of trend inflation and income
            for jj = 2:length(sim_tinf)

                sim_tinf(jj) = sim_tinf(jj-1)*sim_t(burnout+jj-1);
                %sim_incl(jj) = sim_incl(jj-1)*sim_ginc(jj);

            end
            sim_tinf = sim_tinf/mean(sim_tinf);
            
            % ----------- QonQ
            % standard deviation
            std_ypcr(1,cnt_case,robus_f,htm) = nanstd(sim_gcon)*100; 
            std_ypcr(2,cnt_case,robus_f,htm) = nanstd(sim_ginc)*100; 
            std_ypcr(3,cnt_case,robus_f,htm) = nanstd(sim_yp(2,burnout:end).*sim_tinf')*100; 
            std_ypcr(4,cnt_case,robus_f,htm) = nanstd(sim_rate{1,1}(burnout:end).*sim_tinf)*100; 
            std_ypcr(5,cnt_case,robus_f,htm) = nanstd(sim_rate{2,1}(burnout:end).*sim_tinf)*100; 
            std_ypcr(6,cnt_case,robus_f,htm) = nanstd(sim_rate{3,1}(burnout:end).*sim_tinf)*100; 
            
            % cross-correlation 
            xx = corrcoef(sim_yp(2,burnout:end)'.*sim_tinf,sim_ginc','rows','complete'); % inflation vs income
            corr_p_yc(1,cnt_case,robus_f,htm) = xx(2,1);
            xx = corrcoef(sim_yp(2,burnout:end)'.*sim_tinf,sim_gcon,'rows','complete'); % inflation vs consumption
            corr_p_yc(2,cnt_case,robus_f,htm) = xx(2,1);
            xx = corrcoef(sim_ginc',sim_gcon,'rows','complete'); % income vs consumption
            corr_p_yc(3,cnt_case,robus_f,htm) = xx(2,1);
            xx = corrcoef(sim_yp(2,burnout:end)',sim_gcon,'rows','complete'); % inflation gap vs consumption
            corr_p_yc(4,cnt_case,robus_f,htm) = xx(2,1);
            
            % auto correlation
            xx = corrcoef(sim_gcon(1:end-1),sim_gcon(2:end),'rows','complete');
            auto_ypcr(1,cnt_case,robus_f,htm) = xx(2,1);
            xx = corrcoef(sim_ginc(1:end-1),sim_ginc(2:end),'rows','complete');
            auto_ypcr(2,cnt_case,robus_f,htm) = xx(2,1);
            xx = corrcoef(sim_yp(2,burnout:end-1).*sim_tinf(1:end-1)',sim_yp(2,burnout+1:end).*sim_tinf(2:end)','rows','complete');
            auto_ypcr(3,cnt_case,robus_f,htm) = xx(2,1);
            xx = corrcoef(sim_rate{1,1}(burnout:end-1).*sim_tinf(1:end-1),sim_rate{1,1}(burnout+1:end).*sim_tinf(2:end),'rows','complete');
            auto_ypcr(4,cnt_case,robus_f,htm) = xx(2,1);
            xx = corrcoef(sim_rate{2,1}(burnout:end-1).*sim_tinf(1:end-1),sim_rate{2,1}(burnout+1:end).*sim_tinf(2:end),'rows','complete');
            auto_ypcr(5,cnt_case,robus_f,htm) = xx(2,1);
            xx = corrcoef(sim_rate{3,1}(burnout:end-1).*sim_tinf(1:end-1),sim_rate{3,1}(burnout+1:end).*sim_tinf(2:end),'rows','complete');
            auto_ypcr(6,cnt_case,robus_f,htm) = xx(2,1);

            % ----------- YonY
            sim_ginc_y = sim_ginc(1:end-3)/4;
            sim_gcon_y = sim_gcon(1:end-3)/4;
            sim_inf_y  = sim_yp(2,burnout:end-3)'.*sim_tinf(1:end-3)/4;
            sim_infg_y = sim_yp(2,burnout:end-3)'/4;
            for jjj = 1:3
                
                sim_ginc_y = sim_ginc_y + sim_ginc(1+jjj:end-3+jjj)/4;
                sim_gcon_y = sim_gcon_y + sim_gcon(1+jjj:end-3+jjj)/4;
                sim_inf_y  = sim_inf_y  + sim_yp(2,burnout+jjj:end-3+jjj)'.*sim_tinf(1+jjj:end-3+jjj)/4;
                sim_infg_y = sim_infg_y + sim_yp(2,burnout+jjj:end-3+jjj)'/4;
            
            end
            
            % standard deviation
            std_ypcr_y(1,cnt_case,robus_f,htm) = nanstd(sim_gcon_y)*100; 
            std_ypcr_y(2,cnt_case,robus_f,htm) = nanstd(sim_ginc_y)*100; 

            % cross-correlation 
            xx = corrcoef(sim_inf_y,sim_ginc_y','rows','complete');
            corr_p_yc_y(1,cnt_case,robus_f,htm) = xx(2,1);
            xx = corrcoef(sim_inf_y,sim_gcon_y,'rows','complete');
            corr_p_yc_y(2,cnt_case,robus_f,htm) = xx(2,1);
            xx = corrcoef(sim_ginc_y',sim_gcon_y,'rows','complete');
            corr_p_yc_y(3,cnt_case,robus_f,htm) = xx(2,1);
            xx = corrcoef(sim_infg_y,sim_gcon_y,'rows','complete');
            corr_p_yc_y(4,cnt_case,robus_f,htm) = xx(2,1);
           
            % ----------- 2Yon2Y
            sim_ginc_2 = sim_ginc(1:end-7)/8;
            sim_gcon_2 = sim_gcon(1:end-7)/8;
            sim_inf_2  = sim_yp(2,burnout:end-7)'.*sim_tinf(1:end-7)/4;
            sim_infg_2 = sim_yp(2,burnout:end-7)'/8;
            for jjj = 1:7
                
                sim_ginc_2 = sim_ginc_2 + sim_ginc(1+jjj:end-7+jjj)/8;
                sim_gcon_2 = sim_gcon_2 + sim_gcon(1+jjj:end-7+jjj)/8;
                sim_inf_2  = sim_inf_2  + sim_yp(2,burnout+jjj:end-7+jjj)'.*sim_tinf(1+jjj:end-7+jjj)/8;
                sim_infg_2 = sim_infg_2 + sim_yp(2,burnout+jjj:end-7+jjj)'/8;
            
            end
            
            % standard deviation
            std_ypcr_2(1,cnt_case,robus_f,htm) = nanstd(sim_gcon_2)*100; 
            std_ypcr_2(2,cnt_case,robus_f,htm) = nanstd(sim_ginc_2)*100; 

            % cross-correlation
            xx = corrcoef(sim_inf_2,sim_ginc_2','rows','complete');
            corr_p_yc_2(1,cnt_case,robus_f,htm) = xx(2,1);
            xx = corrcoef(sim_inf_2,sim_gcon_2,'rows','complete');
            corr_p_yc_2(2,cnt_case,robus_f,htm) = xx(2,1);
            xx = corrcoef(sim_ginc_2',sim_gcon_2,'rows','complete');
            corr_p_yc_2(3,cnt_case,robus_f,htm) = xx(2,1);
            xx = corrcoef(sim_infg_2,sim_gcon_2,'rows','complete');
            corr_p_yc_2(4,cnt_case,robus_f,htm) = xx(2,1);
           
        end
        
    end
    
    % elb is binding?
    if ( robus_f < 4 || robus_f == 10 )  
        sim_elb = (sim_rate{1,1}(burnout:end).*sim_tinf*pistar*400-400 < 0.1);
    else
        sim_elb = (sim_rate{1,1}(burnout:end).*sim_tinf*400-400 < 0.1);
    end
    
    % average shape of term structure
    yc_n(:,cnt_case,robus_f)...
        = [median(sim_rate{1,1}(burnout:end).*sim_tinf),median(sim_rate{2,1}(burnout:end).*sim_tinf),median(sim_rate{3,1}(burnout:end).*sim_tinf)]*400-400;
    yc_n_rn(:,cnt_case,robus_f)...
        = [median(sim_rate{1,2}(burnout:end).*sim_tinf),median(sim_rate{2,2}(burnout:end).*sim_tinf),median(sim_rate{3,2}(burnout:end).*sim_tinf)]*400-400;
    yc_r(:,cnt_case,robus_f)...
        = [median(sim_rate{1,3}(burnout:end)),median(sim_rate{2,3}(burnout:end)),median(sim_rate{3,3}(burnout:end))]*400-400;
    yc_r_rn(:,cnt_case,robus_f)...
        = [median(sim_rate{1,4}(burnout:end)),median(sim_rate{2,4}(burnout:end)),median(sim_rate{3,4}(burnout:end))]*400-400;
    
    yc_n_el(:,cnt_case,robus_f)...
        = [median(sim_rate{1,1}(sim_elb==1).*sim_tinf(sim_elb==1)),...
           median(sim_rate{2,1}(sim_elb==1).*sim_tinf(sim_elb==1)),...
           median(sim_rate{3,1}(sim_elb==1).*sim_tinf(sim_elb==1))]*400-400;
    yc_n_rn_el(:,cnt_case,robus_f)...
        = [median(sim_rate{1,2}(sim_elb==1).*sim_tinf(sim_elb==1)),...
           median(sim_rate{2,2}(sim_elb==1).*sim_tinf(sim_elb==1)),...
           median(sim_rate{3,2}(sim_elb==1).*sim_tinf(sim_elb==1))]*400-400;
    yc_r_el(:,cnt_case,robus_f)...
        = [median(sim_rate{1,3}(sim_elb==1).*sim_tinf(sim_elb==1)),...
           median(sim_rate{2,3}(sim_elb==1).*sim_tinf(sim_elb==1)),...
           median(sim_rate{3,3}(sim_elb==1).*sim_tinf(sim_elb==1))]*400-400;
    yc_r_rn_el(:,cnt_case,robus_f)...
        = [median(sim_rate{1,4}(sim_elb==1).*sim_tinf(sim_elb==1)),...
           median(sim_rate{2,4}(sim_elb==1).*sim_tinf(sim_elb==1)),...
           median(sim_rate{3,4}(sim_elb==1).*sim_tinf(sim_elb==1))]*400-400;
    
    yc_n_ab(:,cnt_case,robus_f)...
        = [median(sim_rate{1,1}(sim_elb==0).*sim_tinf(sim_elb==0)),...
           median(sim_rate{2,1}(sim_elb==0).*sim_tinf(sim_elb==0)),...
           median(sim_rate{3,1}(sim_elb==0).*sim_tinf(sim_elb==0))]*400-400;
    yc_n_rn_ab(:,cnt_case,robus_f)...
        = [median(sim_rate{1,2}(sim_elb==0).*sim_tinf(sim_elb==0)),...
           median(sim_rate{2,2}(sim_elb==0).*sim_tinf(sim_elb==0)),...
           median(sim_rate{3,2}(sim_elb==0).*sim_tinf(sim_elb==0))]*400-400;
    yc_r_ab(:,cnt_case,robus_f)...
        = [median(sim_rate{1,3}(sim_elb==0).*sim_tinf(sim_elb==0)),...
           median(sim_rate{2,3}(sim_elb==0).*sim_tinf(sim_elb==0)),...
           median(sim_rate{3,3}(sim_elb==0).*sim_tinf(sim_elb==0))]*400-400;
    yc_r_rn_ab(:,cnt_case,robus_f)...
        = [median(sim_rate{1,4}(sim_elb==0).*sim_tinf(sim_elb==0)),...
           median(sim_rate{2,4}(sim_elb==0).*sim_tinf(sim_elb==0)),...
           median(sim_rate{3,4}(sim_elb==0).*sim_tinf(sim_elb==0))]*400-400;
       
    % frequency of elb binding
    freq_elb(cnt_case,robus_f) = sum(sim_elb)/(sim_len-burnout+1); 
    
     
    disp(['robus_f = ',num2str(robus_f)])
      
end

    disp(['cnt_case = ',num2str(cnt_case)])

end

save resultxx