subroutine accel

    use common_var

    implicit none
    
    real(8) :: c_t0, r_t0, b_t1
    
    do dr  = 1, ngrir
    do dt  = 1, ngrit
    do dc  = 1, ngric
    do dyp = 1, ngriyp
        
        ! mp rule
        r_t0 = rmat(dyp,dt,dr)

!$omp parallel do private(c_t0,b_t1,jb,wb,jc,wc,jr,wr,ddb,ddt,ddc,ddr)
    do db  = 1, ngrib
        
        ! optimal consumption and borrowing
        c_t0 = c_t(dyp,dt,db,dr,dc)
        b_t1 = b_t(dyp,dt,db,dr,dc)
        
        ! interpolation for b_t+1 and r_t
        jb(1) = min0(max0(1,int(1 + (b_t1-gridb(1))/((gridb(ngrib)-gridb(1))/(ngrib-1)))),ngrib-1); jb(2) = 1 + jb(1)
        wb(1) = (gridb(jb(2)) - b_t1)/(gridb(jb(2))-gridb(jb(1))); wb(2) = 1.0 - wb(1)
        
        if ( ngrir > 1 ) then
            jr(1) = min0(max0(1,int(1 + (r_t0-gridr(1))/((gridr(ngrir)-gridr(1))/(ngrir-1)))),ngrir-1); jr(2) = 1 + jr(1)
            wr(1) = (gridr(jr(2)) - r_t0)/(gridr(jr(2))-gridr(jr(1))); wr(2) = 1.0 - wr(1)
        else
            wr = (/0.5, 0.5/)
            jr = (/1, 1/)
        endif
        
        if ( ngric > 1 ) then
            jc(1) = min0(max0(1,int(1 + (c_t0-gridc(1))/((gridc(ngric)-gridc(1))/(ngric-1)))),ngric-1); jc(2) = 1 + jc(1)
            wc(1) = (gridc(jc(2)) - c_t0)/(gridc(jc(2))-gridc(jc(1))); wc(2) = 1.0 - wc(1)
        else
            wc = (/0.5, 0.5/)
            jc = (/1, 1/)
        endif
        
        v_t1(:,:,db) = 0.0
        do ddb = 1,2; do ddr = 1,2; do ddc = 1,2
        
            v_t1(:,:,db) = v_t1(:,:,db) + wb(ddb)*wr(ddr)*wc(ddc)*v_tf(:,:,jb(ddb),jr(ddr),jc(ddc)) 
        
        enddo; enddo; enddo; 
                    
        ! AA = E[v^(1-\alp)]^(1/(1-\alp))
        AA(db) = 0.0
        do ddt = 1, ngrit
            
            AA(db) = AA(db) + mct(dt,ddt) * sum( mcyp(dyp,:)*(gridyp(:,1)*v_t1(:,ddt,db))**(1-alp_p) )
            
        enddo
            
        AA(db) = AA(db)**(1.0/(1.0-alp_p))
            
        ! revise v_t
        v_t(dyp,dt,db,dr,dc) = &
            ( (1.0-beta_p)*(c_t(dyp,dt,db,dr,dc)-hab_p*gridc(dc)/gridyp(dyp,1))**(1.0-sig_p) &
            + beta_p*AA(db)**(1.0-sig_p) )**(1.0/(1.0-sig_p))
            
    enddo
    
    enddo
    enddo
    enddo
    enddo

end subroutine    
