module common_var
    
!--------------------------------------------------------------------------------
! Set paramters
!--------------------------------------------------------------------------------

    real(8) :: alp_p     ! risk aversion
    real(8) :: hab_p     ! habit formation
    real(8) :: phir      ! persistency of interest rate
    real(8) :: phip      ! mp rule: inflation
    real(8) :: phiy      ! mp rule: income growth
    real(8) :: elb       ! effective lower bound (ELB) of interest rate
   
    real(8), parameter :: sig_p = 1.0001+1.0   ! inverse of IES
    real(8), parameter :: bst  = 1.2*4     ! steady-state level of bond holdings
    real(8), parameter :: phib = 0.001     ! cost for holding bond

    real(8) :: adjspeed = 1.0     ! adjustment speed for the time iteration
        
    ! # of grids for each variable.
    integer :: ngriy, ngrip, ngrig, ngriyp, ngrib, ngric, ngrir, ngrit
    integer :: dr, dc, dt, dyp, db, ddb, ddr, ddc, ddt
    
    real(8), allocatable, dimension(:) :: gridy, gridp, gridg, gridb, gridr, gridc, gridt, AA, rr_t0
    real(8), allocatable, dimension(:,:) :: gridyp, mcyp, mct
    
    real(8), allocatable :: v_t(:,:,:,:,:)   ! value function for t
    real(8), allocatable :: c_t(:,:,:,:,:)   ! consumption for t
    real(8), allocatable :: b_t(:,:,:,:,:)   ! bond for t
    real(8), allocatable :: lag_t(:,:,:,:,:) ! Lagrange multiplier for t
    
    real(8), allocatable :: v_tf(:,:,:,:,:)  ! value function for t+1
    real(8), allocatable :: c_tf(:,:,:,:,:)  ! consumption for t+1
    
    real(8), allocatable, dimension(:,:,:) :: c_t1, v_t1, rmat
    
    ! asset prices
    real(8), allocatable, dimension(:,:,:,:,:) :: ap_t, ap_tn, ap_tf, ap_tnf, rap_t, rap_tn, rap_tf, rap_tnf
    real(8), allocatable, dimension(:,:,:) :: ap_t1, ap_tn1, rap_t1, rap_tn1, sdf_t1, rsdf_t1
                 
    ! nominal and real yield curve by tenor(1,20,40) and types(risk-averse, risk-neutral)
    real(8), allocatable, dimension(:,:,:,:,:,:) :: yie0_n, yie0_r, yie1_n, yie2_n, yie3_n, yie4_n, yie5_n, yie5_r, yie10_n, yie10_r 
    
    real(8), allocatable :: jbs(:,:,:,:,:,:), wbs(:,:,:,:,:,:), jcs(:,:,:,:,:,:), wcs(:,:,:,:,:,:), jrs(:,:,:,:), wrs(:,:,:,:)
    
    real(8) :: wb(2), wr(2), wc(2), wt(2), wy(2), wp(2)
    integer :: jb(2), jr(2), jc(2), jt(2), jy(2), jp(2)
    
    real(8) :: gpistar(2), gstar, pistar, rstar, beta_p, resid_v0
    
    integer :: cnt_case, robus_f, deaton_f
    character :: cnt*5, sho*4, robus*7
    
end module
