! subroutine for linear interpolation "only for" linearly separted grids. 
subroutine inter_weight(nxx, xx, wxx, jxx, nn)
! NX: actual amount, X: variable, WX(1): weight for lower point, WX(2): weight for upper point, jX: lower and upper point
! N: the number of grids

    use common_var 

    implicit none

    integer, intent(in)  :: nn
    real(8), intent(in)  :: nxx, xx(nn)
    integer, intent(out) :: jxx(2)
    real(8), intent(out) :: wxx(2)

    if ( nn == 1 ) then
        
        wxx = (/0.5, 0.5/)
        jxx = (/1, 1/)
        
    else
    
!        if ( nxx >= xx(nn) ) then   ! The case that optimal amount is BIGGER than the BIGGEST value of grid
!    
!            jxx(1) = nn-1 
!            jxx(2) = nn 
!    
!        elseif ( nxx <= xx(1) ) then  ! The case that optimal amount is SMALER than the SMALEST value of grid
!            
!            jxx(1) = 1
!            jxx(2) = 2
!  
!        else                    ! The case that optimal amount is among grids.
!        
!            jxx(1) = 1 + (nxx-xx(1))/((xx(nn)-xx(1))/(nn-1))
!            jxx(2) = 2 + (nxx-xx(1))/((xx(nn)-xx(1))/(nn-1))
!            
!        endif

        jxx(1) = min0(max0(1,int(1 + (nxx-xx(1))/((xx(nn)-xx(1))/(nn-1)))),nn-1)
        jxx(2) = 1 + jxx(1)
        
        wxx(1) = (xx(jxx(2)) - nxx)/(xx(jxx(2))-xx(jxx(1)))
        wxx(2) = 1.0 - wxx(1)
        
    endif

end subroutine
