! This is a log or linear grid generator
subroutine lgridgen(lbx, ubx, xx1, xx2, widt)
    
    use common_var
    
    implicit none  
    
    real(8), intent(in)  :: lbx, ubx      ! LB and UB is lower and upper bound for grid respectively
    integer, intent(in)  :: xx2, widt     ! X2: The number of grids, widt: type of grids (widt=1: linear, widt=2: log)
    real(8), intent(out) :: xx1(xx2)      ! X1: The variable which we want to descritize
    
    integer :: jj
    
    if ( xx2 == 1 ) then

        xx1 = lbx
        
    else
        
        do jj = 1, xx2
        
            if     ( widt == 1 ) then
                
                xx1(jj) = lbx + (ubx-lbx)/(xx2-1)*(jj-1) ! Make LINEAR grids
                 
            elseif ( widt == 2 ) then
            
                xx1(jj) = exp( log(lbx) + (log(ubx) - log(lbx))/(xx2-1)*(jj-1) ) ! Make LOG grids
                
            endif
            
        enddo
    
    endif
    
end subroutine