! Calculate optimal consumption by Newton Method
subroutine load_files

    use common_var
    
    implicit none
    
    ! country
    select case ( cnt_case ) 
        
        ! Note that rstar set here will not be used if deaton_f == 0
        case (1); cnt = 'c1US/'; rstar = 1.0517**(1.0/4.0)
        case (2); cnt = 'c2UK/'; rstar = 1.0652**(1.0/4.0)
        case (3); cnt = 'c3GE/'; rstar = 1.0312**(1.0/4.0)
        case (4); cnt = 'c4JP/'; rstar = 1.0256**(1.0/4.0)
            
    end select
    
    ! load joint process of income and inflation
    if ( robus_f == 6 .or. robus_f == 14 .or. robus_f == 15 ) then; open (90, file=cnt//robus//'gridyp.txt'); else; open (90, file=cnt//'gridyp.txt'); endif     ! READ shock grids
        read (90, *), gridyp
    close (90)
   
    if ( robus_f == 6 .or. robus_f == 14 .or. robus_f == 15 ) then; open (90, file=cnt//robus//'gridy.txt'); else; open (90, file=cnt//'gridy.txt'); endif     ! READ shock grids
        read (90, *), gridy
    close (90)
   
    if ( robus_f == 6 .or. robus_f == 14 .or. robus_f == 15 ) then; open (90, file=cnt//robus//'gridp.txt'); else; open (90, file=cnt//'gridp.txt'); endif     ! READ shock grids
        read (90, *), gridp
    close (90)
   
    if ( robus_f == 6 .or. robus_f == 14 .or. robus_f == 15 ) then; open (90, file=cnt//robus//'gridg.txt'); else; open (90, file=cnt//'gridg.txt'); endif     ! READ shock grids
        read (90, *), gridg
    close (90)
   
    if ( robus_f == 6 .or. robus_f == 14 .or. robus_f == 15 ) then; open (90, file=cnt//robus//'mcyp.txt'); else; open (90, file=cnt//'mcyp.txt'); endif    ! READ transition matrix
        read (90, *), mcyp
    close (90)
    mcyp = transpose(mcyp)
    
    ! load steady-state inflation and output
    open (90, file=cnt//'gpistar.txt')  ! READ shock grids
        read (90, *), gpistar
    close (90)
    ! Note: originally, gpistar is defined as NET rather than GROSS. 
    gstar  = exp(gpistar(1))
    pistar = exp(gpistar(2))
    
    ! grid for trend inflation
    if ( ngrit == 1 ) then; gridt = 1.0; mct = 1.0 ! a fixed trend inflation
    else

        if ( robus_f == 6 ) then; open (90, file=cnt//robus//'gridt.txt'); else; open (90, file=cnt//'gridt.txt'); endif      ! READ shock grids
            read (90, *), gridt
        close (90)
        
        if ( robus_f == 6 ) then; open (90, file=cnt//robus//'mct.txt'); else; open (90, file=cnt//'mct.txt'); endif     ! READ shock grids
            read (90, *), mct
        close (90)
        mct = transpose(mct)
        
        ! reset pistar and grids for inflation !
        gridp       = gridp/pistar
        gridyp(:,2) = gridyp(:,2)/pistar
        pistar = 1.0

    endif
    
    if ( robus_f == 6 ) then ! stationary
        
       gridy(:)    = gstar
       gridyp(:,1) = gstar
    
    endif
    
    if ( robus_f == 8 ) then ! L4L: zero growth and zero inflation
    
        gridp       = gridp/pistar
        gridyp(:,2) = gridyp(:,2)/pistar
        pistar = 1.0

        gridy       = gridy/gstar
        gridyp(:,1) = gridyp(:,1)/gstar
        gstar = 1.0
    
    elseif ( robus_f == 12 ) then ! L4L: moderately low for long
    
        gridp       = gridp/pistar*(1.015**0.25)
        gridyp(:,2) = gridyp(:,2)/pistar*(1.015**0.25)
        pistar = 1.015**0.25

        gridy       = gridy/gstar*(1.015**0.25)
        gridyp(:,1) = gridyp(:,1)/gstar*(1.015**0.25)
        gstar = 1.015**0.25
    
    elseif ( robus_f == 13 ) then ! L4L: negative growth and negative inflation
    
        gridp       = gridp/pistar*(0.995**0.25)
        gridyp(:,2) = gridyp(:,2)/pistar*(0.995**0.25)
        pistar = 0.995**0.25

        gridy       = gridy/gstar*(0.995**0.25)
        gridyp(:,1) = gridyp(:,1)/gstar*(0.995**0.25)
        gstar = 0.995**0.25
    
    endif
    
    ! set discount rate
    if ( deaton_f == 0 ) then
    
        rstar = gstar*pistar
        beta_p = 0.99875
    
    elseif ( deaton_f == 1 ) then
    
        beta_p = pistar*gstar**sig_p/rstar - 0.001
    
    endif

end subroutine