
% load data
clear; clc

gap_est    = zeros(242,2*4);
gap_est_st = zeros(242,2*4);

for cnt_case = 1:2
for st_nost  = 1:2
    
    cd 'C:\Users\mitsu\Dropbox\01Rsearch\JMCB 2021\term\est_inc_inf JMCB'
    
    if st_nost == 1
        
        switch cnt_case

            case 1; cd '01US'; load 0425us;
            case 2; cd '02UK'; load 0425uk;

        end
        
        gap_est(:,cnt_case*4-3:cnt_case*4) = ...
            [oo_.SmoothedVariables.gU, oo_.SmoothedVariables.yU, oo_.SmoothedVariables.tiU, oo_.SmoothedVariables.piU];
        
    elseif st_nost == 2
        
        switch cnt_case

            case 1; cd '01USst'; load 0426us_st;
            case 2; cd '02UKst'; load 0426uk_st;

        end
        
        gap_est_st(:,cnt_case*4-3:cnt_case*4) = ...
            [zeros(length(oo_.SmoothedVariables.yU),1), oo_.SmoothedVariables.yU, oo_.SmoothedVariables.tiU, oo_.SmoothedVariables.piU];
    
    end
    
end
end

cd 'C:\Users\mitsu\Dropbox\01Rsearch\JMCB 2021\term\est_inc_inf JMCB'


%% draw figures
close all;

% scatter: PC
figure;

for cnt_case = 1:2

    subplot(1,2,cnt_case); 
    plot([0, 0], [-10,10], 'k:','linewidth',0.5); hold on
    plot([-10,10], [0, 0], 'k:','linewidth',0.5); 
    scatter(gap_est(1:end-1,cnt_case*4-2),gap_est(2:end,cnt_case*4),8,'o','filled','b'); 
    hold off
    
    switch cnt_case

        case 1; title('US'); axis([-4 4 -2 2]); 
        case 2; title('UK'); axis([-6 8 -4 8]);

    end
    

end


% scatter: PC by HP gap
figure;

for cnt_case = 1:2

    subplot(1,2,cnt_case); 
    plot([0, 0], [-10,10], 'k:','linewidth',0.5); hold on
    plot([-10,10], [0, 0], 'k:','linewidth',0.5); 
    scatter(gap_est_st(1:end-1,cnt_case*4-2),gap_est_st(2:end,cnt_case*4),8,'o','filled','b'); 
    hold off
    
    switch cnt_case

        case 1; title('US'); axis([-4 4 -2 2]); 
        case 2; title('UK'); axis([-6 8 -4 8]); 

    end
    
end

% scatter: non-stationary trend vs. inflation
figure;

for cnt_case = 1:2

    subplot(1,2,cnt_case); 
    plot([0, 0], [-10,10], 'k:','linewidth',0.5); hold on
    plot([-10,10], [0, 0], 'k:','linewidth',0.5); 
    scatter(gap_est(:,cnt_case*4-3),gap_est(:,cnt_case*4),8,'o','filled','b'); 
    hold off
    
    switch cnt_case

        case 1; title('US'); axis([-3 2 -2 2]);
        case 2; title('UK'); axis([-3 2 -4 8]);

    end

end
